'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Autocomplete = exports.autocompleteFactory = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _reactCssThemr = require('react-css-themr');

var _identifiers = require('../identifiers.js');

var _Chip = require('../chip/Chip.js');

var _Chip2 = _interopRequireDefault(_Chip);

var _Input = require('../input/Input.js');

var _Input2 = _interopRequireDefault(_Input);

var _events = require('../utils/events.js');

var _events2 = _interopRequireDefault(_events);

var _Portal = require('../hoc/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _TransitionGroup = require('react-transition-group/TransitionGroup');

var _TransitionGroup2 = _interopRequireDefault(_TransitionGroup);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable */


var POSITION = {
  AUTO: 'auto',
  DOWN: 'down',
  UP: 'up'
};

var factory = function factory(Chip, Input) {
  var Autocomplete = function (_Component) {
    _inherits(Autocomplete, _Component);

    function Autocomplete() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, Autocomplete);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        focus: false,
        query: _this.props.query
      }, _this.handleChange = function (value, event) {
        if (_this.props.onChange) {
          _this.props.onChange(value, event);
        }
        if (!_this.props.keepFocusOnChange) {
          _this.updateQuery(undefined);
          _this.setState({ query: undefined, focus: false }, function () {
            _reactDom2.default.findDOMNode(_this).querySelector('input').blur();
          });
        }
      }, _this.handleMouseDown = function (event) {
        _this.selectOrCreateActiveItem(event);
      }, _this.handleQueryBlur = function (event) {
        if (_this.state.focus) _this.setState({ focus: false });
        if (_this.props.onBlur) _this.props.onBlur(event, _this.state.active);
      }, _this.updateQuery = function (query) {
        if (_this.props.onQueryChange) _this.props.onQueryChange(query);
        _this.setState({ query: query });
      }, _this.handleQueryChange = function (value, event) {
        if (value === '' && !_this.props.multiple && _this.props.allowClear && _this.props.onChange) {
          _this.props.onChange(null, event);
        }
        _this.updateQuery(value);
        _this.setState({ active: null });
      }, _this.handleQueryFocus = function (event) {
        event.target.scrollTop = 0;
        _this.setState({ active: null, focus: true });
        if (_this.props.onFocus) _this.props.onFocus(event);
      }, _this.handleQueryKeyDown = function (event) {
        if (event.which === 13) {
          _this.selectOrCreateActiveItem(event);
        }

        if (_this.props.onKeyDown) _this.props.onKeyDown(event);
      }, _this.handleQueryKeyUp = function (event) {
        if (event.which === 27) _reactDom2.default.findDOMNode(_this).querySelector('input').blur();

        if ([40, 38].indexOf(event.which) !== -1) {
          var suggestionsKeys = [].concat(_toConsumableArray(_this.suggestions().keys()));
          var index = suggestionsKeys.indexOf(_this.state.active) + (event.which === 40 ? +1 : -1);
          if (index < 0) index = suggestionsKeys.length - 1;
          if (index >= suggestionsKeys.length) index = 0;
          _this.setState({ active: suggestionsKeys[index] });
        }

        if (_this.props.onKeyUp) _this.props.onKeyUp(event);
      }, _this.handleSuggestionHover = function (event) {
        var t = event.target;
        while (t && !t.id) {
          t = t.parentNode;
        }
        _this.setState({ active: t && t.id || '' });
      }, _this.select = function (event, target) {
        _events2.default.pauseEvent(event);
        var newValue = target === void 0 ? event.target.id : target;
        if (_this.isValueAnObject()) {
          newValue = _extends({}, _this.props.value || {}, _defineProperty({}, newValue, true));
        } else if (_this.props.multiple) {
          newValue = [].concat(_toConsumableArray(_this.props.value || []), [newValue]);
        }
        _this.handleChange(newValue, event);
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Autocomplete, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (this.props.query !== nextProps.query) {
          this.setState({ query: nextProps.query });
        }
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(nextProps, nextState) {
        if (!this.state.focus && nextState.focus) {
          this.calculateDirection();
        }
        return true;
      }
    }, {
      key: 'calculateDirection',
      value: function calculateDirection() {
        var client = _reactDom2.default.findDOMNode(this.inputNode).getBoundingClientRect();
        var screen_width = window.innerWidth || document.documentElement.offsetWidth;
        var screen_height = window.innerHeight || document.documentElement.offsetHeight;
        var direction = this.props.direction;
        if (this.props.direction === 'auto') {
          var up = client.top > screen_height / 2 + client.height;
          direction = up ? 'up' : 'down';
        }
        var top = client.top + (window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop) - (document.documentElement.clientTop || document.body.clientTop || 0);
        top = direction == 'down' ? top + client.height + 'px' : top + 'px';
        var bottom = direction == 'up' ? '0px' : undefined;
        var left = client.left + (window.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft) - (document.documentElement.clientLeft || document.body.clientLeft || 0);
        var width = this.props.minWidth && client.width < this.props.minWidth ? this.props.minWidth : client.width;
        if (left + width >= screen_width) {
          left = screen_width - width;
        }
        var maxHeight = direction == 'down' ? screen_height - client.top - client.height : client.top;
        if (maxHeight > screen_height * 0.45) {
          maxHeight = Math.floor(screen_height * 0.45);
        }
        left = left + 'px';
        width = width + 'px';
        maxHeight = maxHeight + 'px';
        if (this.state.top !== top || this.state.left !== left || this.state.width !== width || this.state.bottom !== bottom || this.state.maxHeight !== maxHeight) {
          this.setState({ top: top, bottom: bottom, left: left, width: width, maxHeight: maxHeight });
        }
      }
    }, {
      key: 'selectOrCreateActiveItem',
      value: function selectOrCreateActiveItem(event) {
        var target = this.state.active;
        if (target == null) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = this.suggestions().keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var k = _step.value;

              this.setState({ active: k });
              break;
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          this.select(event, target);
        }
      }
    }, {
      key: 'normalise',
      value: function normalise(value) {
        var sdiak = 'áâäąáâäąččććççĉĉďđďđééěëēėęéěëēėęĝĝğğġġģģĥĥħħíîíîĩĩīīĭĭįįi̇ıĵĵķķĸĺĺļļŀŀłłĺľĺľňńņŋŋņňńŉóöôőøōōóöőôøřřŕŕŗŗššśśŝŝşşţţťťŧŧũũūūŭŭůůűűúüúüűųųŵŵýyŷŷýyžžźźżżß';
        var bdiak = 'AAAAAAAACCCCCCCCDDDDEEEEEEEEEEEEEGGGGGGGGHHHHIIIIIIIIIIIIIIJJKKKLLLLLLLLLLLLNNNNNNNNNOOOOOOOOOOOORRRRRRSSSSSSSSTTTTTTUUUUUUUUUUUUUUUUUWWYYYYYYZZZZZZS';

        var normalised = '';
        for (var p = 0; p < value.length; p++) {
          if (sdiak.indexOf(value.charAt(p)) !== -1) {
            normalised += bdiak.charAt(sdiak.indexOf(value.charAt(p)));
          } else {
            normalised += value.charAt(p);
          }
        }

        return normalised.toLowerCase().trim();
      }
    }, {
      key: 'suggestions',
      value: function suggestions() {
        var suggest = new Map();
        var source = this.source();
        var query = this.normalise(this.state.query == null ? '' : this.state.query + '');

        if (query !== '' && this.props.suggestionMatch !== 'disabled' && this.props.suggestionMatch !== 'none') {
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = source[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var _step2$value = _slicedToArray(_step2.value, 2),
                  key = _step2$value[0],
                  value = _step2$value[1];

              if (this.matches(this.normalise(value), query)) {
                suggest.set('' + key, value);
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        } else {
          suggest = this.props.multiple ? new Map(source) : source;
        }
        if (this.props.multiple) {
          var values = this.isValueAnObject() ? Object.keys(this.props.value) : this.props.value || [];
          var _iteratorNormalCompletion3 = true;
          var _didIteratorError3 = false;
          var _iteratorError3 = undefined;

          try {
            for (var _iterator3 = values[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
              var k = _step3.value;

              suggest.delete('' + k);
            }
          } catch (err) {
            _didIteratorError3 = true;
            _iteratorError3 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
              }
            } finally {
              if (_didIteratorError3) {
                throw _iteratorError3;
              }
            }
          }
        }

        return suggest;
      }
    }, {
      key: 'matches',
      value: function matches(value, query) {
        var suggestionMatch = this.props.suggestionMatch;


        if (suggestionMatch === 'start') {
          return value.startsWith(query);
        } else if (suggestionMatch === 'anywhere') {
          return value.includes(query);
        } else if (suggestionMatch === 'word') {
          var re = new RegExp('\\b' + query, 'g');
          return re.test(value);
        }

        return false;
      }
    }, {
      key: 'source',
      value: function source() {
        var src = this.props.source;
        if (this._cachedSource != src) {
          this._cachedSource = src;
          var valueKey = this.props.valueKey || 'value';
          var labelKey = this.props.labelKey || 'label';
          if (src.hasOwnProperty('length')) {
            this._source = new Map(src.map(function (item) {
              if (Array.isArray(item)) {
                return ['' + item[0], item[1]];
              } else if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) != 'object') {
                return ['' + item, item];
              } else {
                return ['' + item[valueKey], item[labelKey]];
              }
            }));
          } else {
            this._source = new Map(Object.keys(src).map(function (key) {
              return ['' + key, src[key]];
            }));
          }
        }
        return this._source;
      }
    }, {
      key: 'unselect',
      value: function unselect(key, event) {
        if (!this.props.disabled) {
          var newValue = void 0;
          if (this.isValueAnObject()) {
            newValue = _extends({}, this.props.value);
            delete newValue[key];
          } else if (this.props.multiple) {
            newValue = (this.props.value || []).filter(function (v) {
              return v != key;
            });
          }
          this.handleChange(newValue, event);
        }
      }
    }, {
      key: 'isValueAnObject',
      value: function isValueAnObject() {
        return this.props.value && !Array.isArray(this.props.value) && _typeof(this.props.value) === 'object';
      }
    }, {
      key: 'mapToObject',
      value: function mapToObject(array) {
        return array.reduce(function (obj, k) {
          obj[k] = true;
          return obj;
        }, {});
      }
    }, {
      key: 'renderSelected',
      value: function renderSelected() {
        var _this2 = this;

        if (this.props.multiple) {
          var values = this.isValueAnObject() ? Object.keys(this.props.value) : this.props.value || [];
          var source = this.source();
          var selectedItems = values.map(function (key) {
            return _react2.default.createElement(
              Chip,
              {
                key: key,
                className: _this2.props.theme.value,
                deletable: true,
                onDeleteClick: _this2.unselect.bind(_this2, key)
              },
              source.get('' + key)
            );
          });

          return _react2.default.createElement(
            'ul',
            { className: this.props.theme.values },
            selectedItems
          );
        }
      }
    }, {
      key: 'renderSuggestions',
      value: function renderSuggestions() {
        var _this3 = this;

        var theme = this.props.theme;

        return [].concat(_toConsumableArray(this.suggestions())).map(function (_ref2) {
          var _ref3 = _slicedToArray(_ref2, 2),
              key = _ref3[0],
              value = _ref3[1];

          var className = (0, _classnames4.default)(theme.suggestion, _defineProperty({}, theme.active, _this3.state.active === key));
          return _react2.default.createElement(
            'li',
            {
              id: key,
              key: key,
              className: className,
              onMouseDown: _this3.handleMouseDown,
              onMouseOver: _this3.handleSuggestionHover
            },
            value
          );
        });
      }
    }, {
      key: 'renderSuggestionList',
      value: function renderSuggestionList() {
        var theme = this.props.theme;
        var _state = this.state,
            top = _state.top,
            bottom = _state.bottom,
            maxHeight = _state.maxHeight,
            left = _state.left,
            width = _state.width;

        return _react2.default.createElement(
          _TransitionGroup2.default,
          { style: { position: 'absolute', top: top, left: left, width: width } },
          _react2.default.createElement(
            _Transition2.default,
            {
              appear: true,
              timeout: 0,
              onEntered: function onEntered(node, appearing) {
                node.style.maxHeight = maxHeight;
              } },
            _react2.default.createElement(
              'ul',
              { style: { bottom: bottom },
                className: theme.suggestions },
              this.renderSuggestions(),
              this.props.more ? _react2.default.createElement(
                'li',
                { className: theme.suggestion },
                this.props.more
              ) : null
            )
          )
        );
      }
    }, {
      key: 'render',
      value: function render() {
        var _this4 = this;

        var _props = this.props,
            placeholder = _props.placeholder,
            allowClear = _props.allowClear,
            className = _props.className,
            clearTooltip = _props.clearTooltip,
            disabled = _props.disabled,
            error = _props.error,
            label = _props.label,
            value = _props.value,
            selectedPosition = _props.selectedPosition,
            style = _props.style,
            theme = _props.theme,
            multiple = _props.multiple;

        var inputProps = this.props.inputProps || {};
        var outerClassName = (0, _classnames4.default)(theme.autocomplete, _defineProperty({}, theme.focus, this.state.focus), className);
        var withClear = allowClear && (multiple ? value && Object.keys(value).length > 0 : value != null);
        return _react2.default.createElement(
          'div',
          { 'data-react-toolbox': 'autocomplete', className: outerClassName, style: style },
          selectedPosition === 'above' ? this.renderSelected() : null,
          withClear ? _react2.default.createElement(
            'span',
            {
              className: 'material-icons ' + theme.clear,
              title: clearTooltip,
              onClick: function onClick(e) {
                return _this4.handleChange(multiple ? [] : null, e);
              } },
            'clear'
          ) : null,
          _react2.default.createElement(Input, _extends({}, inputProps, {
            ref: function ref(node) {
              _this4.inputNode = node;
            },
            autoComplete: 'off',
            className: theme.input + (withClear ? ' ' + theme.withclear : ''),
            placeholder: placeholder,
            disabled: disabled,
            error: error,
            label: label,
            onBlur: this.handleQueryBlur,
            onChange: this.handleQueryChange,
            onFocus: this.handleQueryFocus,
            onKeyDown: this.handleQueryKeyDown,
            onKeyUp: this.handleQueryKeyUp,
            theme: theme,
            themeNamespace: 'input',
            value: this.state.query == null ? multiple || value == null ? '' : this.source().get('' + value) : this.state.query
          })),
          _react2.default.createElement(
            _Portal2.default,
            null,
            this.state.focus ? this.renderSuggestionList() : null
          ),
          selectedPosition === 'below' ? this.renderSelected() : null
        );
      }
    }]);

    return Autocomplete;
  }(_react.Component);

  Autocomplete.propTypes = {
    allowClear: _propTypes2.default.bool,
    clearTooltip: _propTypes2.default.string,
    className: _propTypes2.default.string,
    direction: _propTypes2.default.oneOf(['auto', 'up', 'down']),
    disabled: _propTypes2.default.bool,
    error: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
    keepFocusOnChange: _propTypes2.default.bool,
    label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
    labelKey: _propTypes2.default.string,
    valueKey: _propTypes2.default.string,
    multiple: _propTypes2.default.bool,
    onBlur: _propTypes2.default.func,
    onChange: _propTypes2.default.func,
    onFocus: _propTypes2.default.func,
    onKeyDown: _propTypes2.default.func,
    onKeyUp: _propTypes2.default.func,
    onQueryChange: _propTypes2.default.func,
    query: _propTypes2.default.string,
    selectedPosition: _propTypes2.default.oneOf(['above', 'below', 'none']),
    source: _propTypes2.default.any,
    minWidth: _propTypes2.default.number,
    more: _propTypes2.default.string,
    suggestionMatch: _propTypes2.default.oneOf(['disabled', 'start', 'anywhere', 'word', 'none']),
    theme: _propTypes2.default.shape({
      active: _propTypes2.default.string,
      autocomplete: _propTypes2.default.string,
      focus: _propTypes2.default.string,
      input: _propTypes2.default.string,
      suggestion: _propTypes2.default.string,
      suggestions: _propTypes2.default.string,
      up: _propTypes2.default.string,
      value: _propTypes2.default.string,
      values: _propTypes2.default.string
    }),
    value: _propTypes2.default.any,
    inputProps: _propTypes2.default.object
  };
  Autocomplete.defaultProps = {
    allowClear: false,
    clearTooltip: 'Clear',
    className: '',
    direction: 'auto',
    keepFocusOnChange: false,
    multiple: true,
    selectedPosition: 'above',
    source: {},
    suggestionMatch: 'start'
  };


  return Autocomplete;
};

var Autocomplete = factory(_Chip2.default, _Input2.default);
exports.default = (0, _reactCssThemr.themr)(_identifiers.AUTOCOMPLETE, null, { withRef: true })(Autocomplete);
exports.autocompleteFactory = factory;
exports.Autocomplete = Autocomplete;